//more patterns.  out-of-phase.  16 vs 15
//buttons sets the speed
//knob sets scale
//digital input pin 1 bypasses the speed and knob scaling

//speaker + 7 buttons (pins 1-7) + knob (analog input 0)

int outPin= 9;  //speaker output pwm9
int ain= 0;     //knob input analog 0

float dscale, fscale;
int freq[]= {250, 200, 50, 50, 100, 250, 200, 200, 150, 50, 100, 250, 50, 150, 200};  //15 freqs
int durs[]= {5, 175, 175, 5, 25, 175, 125, 75, 250, 175, 100, 5, 5, 175, 5, 5};  //16 durs
int index= 0;

void setup() {
  pinMode(outPin, OUTPUT);   //speaker pin as output
  DDRD= DDRD|B11111110;      //pins 1-7 as inputs
  PORTD= B11111110;          //activate internal pullup
}

void loop() {
  int fre= freq[index%(sizeof(freq)/sizeof(int))];
  int dur= durs[index%(sizeof(durs)/sizeof(int))];
  index= index+1;
  
  if(digitalRead(1)==HIGH) {       //if digitalinput 0 is high then scale, else don't - so we can hear phaseout on its own
    dscale= (PIND>>2)/32.0;        //scale durations with buttons.  factor 0-2
    dur= int(dur*dscale);
    fscale= analogRead(ain)/512.0;  //scale frequencies with knob.  factor 0-2
    fre= int(fre*fscale);
  }
  
  for(int i= 0; i<dur; i++) {
    digitalWrite(outPin, HIGH);
    delayMicroseconds(fre);
    digitalWrite(outPin, LOW);
    delayMicroseconds(fre);
  }
}
