//same as onebit_pwm02 but with buttons controlling different settings

//speaker + 4 buttons

int outPin= 9;  //speaker output pwm9
int but0= 2;    //button input digital 2
int but1= 3;    //button input digital 3
int but2= 4;    //button input digital 4
int but3= 5;    //button input digital 5

int i;          //lfo counter
int freq= 8;    //lfo freq
int maxLfo= 255;
int transp= 0;  //transpose

void setup() {
  pinMode(but0, INPUT);
  pinMode(but1, INPUT);
  pinMode(but2, INPUT);
  pinMode(but3, INPUT);
  digitalWrite(but0, HIGH);    //activate internal pullup
  digitalWrite(but1, HIGH);
  digitalWrite(but2, HIGH);
  digitalWrite(but3, HIGH);
  
  TCCR1A= B11110010;     //timer setup (see meg8 datasheet table39)
  TCCR1B= B00011100;     //try changing the 3 last bits (see meg8 datasheet table40)
  ICR1= 80;             //set counter maximum - sort of base freq
  DDRB= (1<<1);          //same as pinMode(outPin, OUTPUT);
}
void loop() {
  
  //--buttons
  if(digitalRead(but0)==HIGH) {
    ICR1= 15+transp;
  } else {
    ICR1= 8+transp;
  }
  if(digitalRead(but1)==HIGH) {
    maxLfo= 64;
  } else {
    maxLfo= 255;
  }
  if(digitalRead(but2)==HIGH) {
    freq= 1;
  } else {
    freq= 8;
  }
  if(digitalRead(but3)==HIGH) {
    transp= 12;
  } else {
    transp= 0;
  }
  
  //--lfo
  for(i= 0; i<=maxLfo; i++) {
    OCR1A= i;            //same as analogWrite(outPin, i);
    delay(freq);
  }
}
