//similar to onebit_pwm03 but with more buttons and more efficient settings

//speaker + 6 buttons (pins 2-7)

int outPin= 9;  //speaker output pwm9

int i;          //lfo counter
int freq= 8;    //lfo freq
int maxLfo= 255;
int transp= 0;  //transpose

void setup() {
  DDRD= DDRD|B11111100;      //pins 2-7 as inputs
  PORTD= B11111100;          //activate internal pullup
  
  TCCR1A= B11110010;     //timer setup (see meg8 datasheet table39)
  TCCR1B= B00011100;     //try changing the 3 last bits (see meg8 datasheet table40)
  ICR1= 80;              //set counter maximum - sort of base freq
  DDRB= (1<<1);          //same as pinMode(outPin, OUTPUT);
  Serial.begin(9600);    //talk back to computer
}

void loop() {
  
  //--buttons
  Serial.println(PIND>>2, BIN);  //send info to computer about button states
  switch(PIND>>2) {
    case 63:
      freq= 180;
      maxLfo= 10;
      transp= 3;
      ICR1= 10;
      break;
    case 62:
      freq= 80;
      maxLfo= 100;
      transp= 0;
      ICR1= 100;
      break;
    case 61:
      freq= 100;
      maxLfo= 48;
      transp= 0;
      ICR1= 10;
      break;
    case 60:
      freq= 123;
      maxLfo= 6;
      transp= 70;
      ICR1= 53;
      break;
    case 59:
      freq= 164;
      maxLfo= 125;
      transp= 0;
      ICR1= 102;
      break;
    case 58:
      freq= 4;
      maxLfo= 5;
      transp= 5;
      ICR1= 6;
      break;
   case 57:
      freq= 14;
      maxLfo= 15;
      transp= 15;
      ICR1= 16;
      break;
    
     //etc. can add many more 'presets' here - down to 0
  }
  
  //--lfo
  for(i= 0; i<=maxLfo; i++) {
    OCR1A= i;            //same as analogWrite(outPin, i);
    delay(freq);
  }
}
